function output_image = Bandlimit(input_image, viewpos, noise_type, noise_param)

[h,w] = size(input_image);
output_image = zeros(h,w);
blfilter = filtershape(w, viewpos, noise_type, noise_param);
for idy = 1:h
    FFT_input= fftshift(fft2(input_image(idy,:)));
    FFT_processed = FFT_input .* blfilter;
    output_image(idy,:) = real(ifft2(fftshift((FFT_processed))));
end

function output_shape = filtershape(w, viewpos, noise_type, noise_param)

output_shape = zeros(1,w);
if strcmp(noise_type, 'uniform')
    if(viewpos == 0.25)
        threshold = 7.86;
    else
        threshold = 5.16;
    end
elseif strcmp(noise_type, 'gaussian')
    if(viewpos == 0.25)
        threshold = 5.29;
    else
        threshold = 3.33;
    end
else
    threshold = 0.0;
end

for idx = 1:w
    omega = (idx - floor(w/2) - 1)/w * (2*pi);

    if abs(omega * noise_param) <= threshold
        output_shape(idx) = 1;
    else
        output_shape(idx) = 0;
    end
end
