function target_view = ViewInterpolation(left, right, depth, viewpos, noise_param, noise_type, prefilter)

if strcmp(prefilter, 'prefilter')    
    left_filtered = Prefilter(left, viewpos, noise_param, noise_type);
    right_filtered = Prefilter(right, 1-viewpos, noise_param, noise_type); 
else
    left_filtered = left*(1-viewpos);
    right_filtered = right*viewpos;
end    
    
target_view = shift_and_add(left_filtered, right_filtered, depth, viewpos);
    
function target_view = shift_and_add(left, right, depth, viewpos)

[height,width] = size(left);
target_view = zeros(size(left));

global interp_type;

for picy = 1:height
    xori = 1:width;
    disparity = depth(picy,:); 
    target_view(picy,:) = interp1(xori, left(picy,:), xori + viewpos*disparity, interp_type);
    target_view(picy,:) = target_view(picy,:) + interp1(xori, right(picy,:), xori - (1-viewpos)*disparity, interp_type);
end

target_view = target_view .* (depth ~= 0);







